/*****************************************************************

	Blossom registers

	RGM 17 October 1988

	C structure version

	THG 24 October 1988

*****************************************************************/

#define NUM_VREGS 	9		/* Number of video registers */
#define VREG_BASE 	0x40000040	/* Base of video registers */
#define BLOSSOM_BASE	((BlossomPtr)0x40000000)/* Base of everything */
#define BLITTER_BASE	((BlitterPtr)0x40000080)/* Base of blitter registers */

typedef struct _Blossom {
	int	MC;		/* Master control */
	int	EA;		/* Event line address */
	int	TS;		/* Test (leave alone!) */
	int	OB;		/* I/O bits */

	int	T0;
	int	T1;		/* writes as EV */

	int	pad1[0xA];

	int	HT;
	int	HD;
	int	HS;
	int	HW;

	int	VT;
	int	VD;
	int	VS;
	int	VW;
	int	VC;
} Blossom, *BlossomPtr;

typedef struct _Blitter {
	int	DS;
	int	DF;
	int	DT;
	int	DI;
	int	DW;
	int	DL;

	int	MS;
	int	MB;

	int	SS;
	int	SF;
	int	ST;
	int	SI;

	int	BF;
	int	TC;
	int	PM;
	int	TV;

	int	SD;		/* also SP */
	int	DD;
	int	MD;
	int	BC;

	int pad3[0x2C];

	int	LS;
	int	LF;
	int	LT;
	int	LI;
} Blitter, *BlitterPtr;

/*****************************************************************/

#define	BCgo	0x80000000
#define	BCresb	0x40000000
#define	BCssp	0x20000000
#define	BCssh	0x10000000

#define	BCstp	0x08000000
#define	BCsrc	0x04000000
#define	BCdst	0x02000000
#define	BCmsk	0x01000000

#define	BCfcen	0x00800000
#define	BCeols	0x00400000

#define	BCmps	0x00100000
#define	BCmpr	0x00010000

#define	BCdq	0x00004000
#define	BCdps	0x00001000
#define	BCdxc	0x00000400
#define	BCdyc	0x00000100
#define	BCsq	0x00000040
#define	BCsps	0x00000010
#define	BCsxc	0x00000004
#define	BCsyc	0x00000001

