/***********************************************************
bloss.c
A somewhat random selection of graphics routines for Blossom
Updates:

17 October 1988	RGM	Written
***********************************************************/

#include "blossom.h"
#include "helios.h"
#include "video.h"
#include "stdio.h"

/**********************************************************
Initialise the graphics registers to default values

Assumes that the blitter has been enabled.
**********************************************************/
static void bl_init()
{
WORD	*px;

px = (WORD *)MC_REG;
*px = 0x4a;

px = (WORD *)MB_REG;
*px = 0xff00;		/* top/bot masks both true */

px = (WORD *)BF_REG;
*px = 10;		/* Bit function = source */

px = (WORD *)TC_REG;
*px = 1;		/* FWR = 1. Ignore linear tests */

px = (WORD *)PM_REG;
*px = 0xffffffff;	/* Planar mask, all bits true */

px = (WORD *)MD_REG;
*px = 0xffffffff;	/* Bit mask data, all true */

px = (WORD *)DD_REG;
*px = 0xffffffff;	/* Destination data */

px = (WORD *)SD_REG;
*px = 0xffffffff;	/* Source data */

px = (WORD *)BC_REG;
*px = 0x00000000;	/* Reset everything */

}

/***********************************************************
Clear the screen using stipple mode with fixed source data
***********************************************************/
static void bl_stip(start,width,height,col,stipple)

BYTE	col;
WORD	start,width,height,stipple;
{
WORD	*px;

	px=(WORD *)DS_REG;
	*px++ = (MAP1+start)*2;		/* Nibble address */
	px++;
	*px++ = 2048*4*2;	/* Stride is 4 lines, in nibbles */
	px++;
	*px++ = ((width/4)-1)<<3;	/* width in words */
	*px   = (height/4)-1;		/* Length in lines */
	
	px=(WORD *)SD_REG;
	*px++ = stipple;		/* Stipple pattern */
	*px++ = ((((((col<<8)+col)<<8)+col)<<8)+col);	/* Colour */
	px++;
	*px++ = BCgo + BCstp + BCeols+	/* Blitter control register */
	        BCdxc*1 + BCdyc*0 +
	        BCsxc*1 + BCsyc*0;
}

int main(int argc, char *argv[])
{
WORD	start,width,height,stipple,delay;
BYTE	col;
WORD	tt = 0;

start = 100*2048 + 100;
width = 100;
height = 200;
col = 0x01;
stipple = 0xffffffff;
bl_init();

if (argc == 6) {
	start = atoi(argv[1]);
	width = atoi(argv[2]);
	height = atoi(argv[3]);
	col = atoi(argv[4]);
	delay = atoi(argv[5]);
}
printf("start,width,height,col\n <Return> to continue\n");
while(getchar()!='\n');

while (1) {
	if(delay)
		while(getchar()!='\n');
	bl_stip(start,width,height,col++,stipple);
	printf("done! %d \n",tt++);
	start += 73;
	if ((start&0x3ff)>1280)
		start = (start+8003)&0xfffffc00;
	if (start > 2048*960)
		start = 0;
	}
}

