/************************************************************************/
/*                                                                      */
/* File: tblit.c	                                                */
/*          								*/
/************************************************************************/

#include "helios.h"
#include "task.h"
#include "blossom.h"
#include "video.h"

WORD DEBUG = 1;

extern void bytblt(WORD *,WORD *,WORD,WORD,WORD,WORD,WORD,WORD,WORD);

/*  bytblt(src,dst,src offset,dst offset,src stride,dst stride,dst height
           dst width,opcode)

    opcode = 0 ==> copy always
	     1 ==> copy if source != 0
             2 ==> copy if source = 0
*/

/******************************************************************
blits()

This function uses the T800 2D block copy function, which is
implemented with the library function bytblt(...) described above.

******************************************************************/

void main()
{
WORD *src,*dst,i;
WORD	debug = 0;
WORD	count = 0;
BYTE col;
printf("starting...");

testvid();
while(1) {
   for(i=0;i<100;i++) {
/*
	printf("About to set fast (internal) RAM to %x \n",col);
	src = &col;
	dst = MinInt + (1024*3);
	bytblt(src,dst,0,0,0,1,1024,1,0);

	printf("About to fast copy from fast RAM to VRAM \n");
	src = dst;
	dst = MAP1 + (768*2048/2);
	bytblt(src,dst,0,0,0,2048,100,1024,0);
*/
	if (debug)
		printf("About to fast copy from VRAM to main RAM \n");
	src = MAP1;
	dst = MinInt + (1024*1024*2);
	bytblt(src,dst,0,0,2048,1024,100,1024,0);

	if (debug)
		printf("About to fast copy from RAM to RAM\n");
	src = dst;
	dst = MinInt + (1024*1024*3);
	bytblt(src,dst,0,0,1024,1024,100,1024,0);

	if (debug)
		printf("About to fast copy from RAM to VRAM \n");
	src = dst;
	dst = MAP1 + (2048*512);
	bytblt(src,dst,0,0,1024,2048,100,1024,0);

	if (debug)
		printf("About to fast copy from VRAM to VRAM \n");
	src = dst;
	dst = MAP1;
	bytblt(src,dst,0,0,2048,2048,100,1024,0);

	}
   printf("%ld interations\n",count++);
   }
}


void readmain()
{
WORD *ramaddr = 0x80020000;
WORD i,x;

while (1) {
	for (i=0; i <= 0x7FFFFFFE; i++) {
		*ramaddr = i;
		x = *ramaddr;
		}
	printf("%x \n",i);
	}
}

/****************************************************************************
  testmain()
****************************************************************************/

void testmain(startram,endram)
WORD *startram,*endram;
{
WORD *i;
WORD incr, length, mask;
WORD *x = 0x80000910L;
WORD *j = 0x80000920L;

incr = *x;		/* only needed by overwrite test, currently not used */


mask = 0xAAAAAAAA;
printf("Testing main RAM with data %lx\n",mask);
for (i=startram; i < endram; i++)
	{
	*i = mask;
	}
for (i=startram; i < endram; i++)
	{
	if (*i != mask) printf ("Address %lx failed with %lx \n",i,*i);
	}
printf("OK ... \n");


mask = 0x55555555;
printf("Testing main RAM with data %lx\n",mask);
for (i=startram; i < endram; i++)
	{
	*i = mask;
	}
for (i=startram; i < endram; i++)
	{
	if (*i != mask) printf ("Address %lx failed with %lx \n",i,*i);
	}
printf("OK ...\n");


printf("Testing main RAM with addresses \n");
for (i=startram; i < endram; i++)
	{
	*i = i;
	}
for (i=startram; i < endram; i++)
	{
	x = *i;
	if (x != i) printf ("Address %lx failed with %lx \n",i,*i);
	}
printf("OK from %lx to %lx\n",startram,endram);

/*
mask = 0x5a5a5a5aL;
printf("Overwrite test...\n");
for (i=startram; i<endram; i += incr)
    {
	*i = mask;
	for(j=0x80000800L;(WORD)j<0x80010000L; j++)
	    {
		if(*j == mask)
		    printf("\nError: writing to %lx overwrote %lx\n",i,j);
	    }
	if( !( (WORD)i & 0x3fff) ) printf("  %lx\n",i);
    }
printf("\nOverwrite test done.\n");
*/
}


/***************************************************************************
    vloop()
***************************************************************************/

void vloop()
{
WORD *i;
WORD x = 0x55555555L;

i = 0x00355154;		/* map 1, CAS addr = inverse of RAS addr */


while (1) {
	  *i = x;
	  x = *i;
 	  }
}

testvid()
{
WORD *i;
WORD *endram = (WORD *)0x00800000;
WORD *startram = (WORD *)0x00600000;
WORD mask,x,val,bk;
int j;

mask = 0x55555555;
printf("Writing video RAM with data %lx\n",mask);
for (i=startram; i < endram; i++)
	{
	*i = mask;
	}
printf("Reading back ...\n");
for (i=startram; i < endram; i++)
 	{
	x = *i;
	if ((x != mask)&&(DEBUG>0)) 
	printf ("Address %lx Mask %lx Read %lx Then %lx Then %lx \n",
	i,mask,x,*i,*i);
	}
printf("OK ... \n");

mask = 0xFFFFFFFF;
for (i=startram; i < endram; i++)
	{
	*i = mask;
	}

mask = 0xAAAAAAAA;
printf("Writing video RAM with data %lx\n",mask);
for (i=startram; i < endram; i++)
	{
	*i = mask;
	}
printf("Reading back ...\n");
for (i=startram; i < endram; i++)
	{
	x = *i;
	if ((x != mask)&&(DEBUG>0))
	printf ("Address %lx Mask %lx Read %lx Then %lx Then %lx \n",
	i,mask,x,*i,*i);
	}
printf("OK ...\n");

mask = 0;
for (i=startram; i < endram; i++)
	{
	*i = mask;
	}

printf("Writing video RAM with addresses\n");
startram=0x00600000L;
endram=0x00800000L;
for(i=startram;i<endram;i+=512)
	{
	    for(j=0;j<512;j++,i++)
		*i=i;
	}

printf("Reading addresses back...\n");
for(i=startram;i<endram;i+=512)
	{
	   for(j=0;j<512;j++,i++)
	   {
	      x = *i;
	      val = i;
	      if((WORD)x != val){
	         bk = ((((WORD)i>>10)&1)+(((WORD)i>>11)&2));
	         printf("Address %lx was %lx, then %lx then %lx Bank %lx\n",i,
	                 x,*i,*i,bk);}
		}
	}
printf("OK ....\n");

					
printf("Writing video RAM with EOR of address\n");
startram=0x00600000L;
endram=0x00800000L; /* map 3 */
for (i=startram; i < endram; )
 {
    for(j=0;j<512;j++, i++)
	  *i = ((WORD)i)^0xffffffffL;
    i+=512; /* step pointer on over shadowed area */
 }
printf("Reading back ...\n");
for (i=startram; i < endram; )
	{
         for(j=0;j<512;j++, i++)
	  {
 	   x = *i;
	   val=((WORD)i)^0xffffffffL;
	   if ( (x != val) && (DEBUG>0) ){
	      bk = ((((WORD)i>>10)&1)+(((WORD)i>>11)&2));
	      printf ("Address %lx Bank %lx  %lx Read %lx Then %lx Then %lx \n",
	          i,bk,val,x,*i,*i);}
	  }
	 i+=512; /* step pointer on over shadowed area */
	}
printf("OK ...\n");

}
