/* PCW Benchmarks Version 1.1        Copywrite (C) TransTiriel        1990
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <limits.h>
#include <math.h>
#include <float.h>

#define ATW
/* #define LATTICE_C */

#ifdef ATW
#define SBASE        (char*)0x00200000         /* Base address for screen (Mode 1) */
#define SSTRIDE        11                        /* Amount to shift to get y co-ord 1<<11 = 2048 */
#define FLOPPY_FILE "/a/test"
#define HARD_FILE   "/usr/temp/test"
#define FORM_FEED   putchar( '\f' ) ;
#endif

/* -------------------------------------------------------------------------------- */

#ifdef LATTICE_C

#define CLK_TCK 200
#define clock_t unsigned long
#define SEEK_SET 0
#define FLT_MAX_10_EXP FLT_MAX_EXP
#define FLOPPY_FILE "a:test"
#define HARD_FILE   "c:test"
#define FORM_FEED   fputs( "\0x1bH\0x1bJ\0x1bK", stdout )
long *_timer = (long*)0x4BA ;

unsigned long start = 0 ;
clock_t clock( void )
{
        int result ;
        long _clock ;

        result = gemdos( 0x20, 0 ) ;
        _clock = *_timer ;
        result = gemdos( 0x20, result ) ;

        return( (clock_t)(_clock) ) ;
}

#endif

/* -------------------------------------------------------------------------------- */

/* These are the global variables used at initialisation time for the PCW/BSI
 * benchmarks
 */
char tmach[100], tinter[100] ;
char dskpth[100], flname[100] ;

int  sw, sd, gsw, gsh, sc ;
int smode, rmin, rmax ;

float calibrat ;

double fill, scroll, graph, seqmem, ranmem, integer, real, sequen, random ;

/* Emulate basic input (for text) */
void tinput( msg, reply )
char *msg, *reply ;
{
        fputs( msg, stdout ) ;
        putchar ( '\?' ) ;        fflush( stdout ) ;
        gets( reply ) ;
}

/* Emulate basic input (for integers) */
int ninput( msg )
char *msg ;
{
        int n ;
        char reply[100] ;
        
        tinput( msg, reply ) ;
        n = atoi( reply ) ;
        
        return( n ) ;
}

void user_input( void )
{
        tinput( "ENTER THE NAME OF THE MACHINE TO BE TESTED", tmach ) ;
        tinput( "ENTER THE NAME/VERSION OF THE BASIC INTERPRETER", tinter ) ;

        sw = ninput( "TEXT SCREEN WIDTH (80) " ) ;
        if( !sw )        sw = 80 ;
        sd = ninput( "TEXT SCREEN HEIGHT (24) " ) ;
        if( !sd )        sd = 24 ;

        do
        {
                smode = 2 ;
                gsw = 640 ;
                gsh = 200 ;
        
                sc = ninput( "SCREEN ADAPTER 1 ) CGA  2 ) EGA  3 ) VGA" ) ;
        }
        while( sc < 1  ||  sc > 3 ) ;
        
        if( sc != 1 )
        {
                smode = 9 ;
                gsh = 350 ;
        }
        
        /* For user consistency */
        rmin = ninput( "TYPE IN BOTTOM VALUE OF RAM ( 10000 )" ) ;
        rmax = ninput( "TYPE IN TOP VALUE OF RAM ( 60000 )" ) ;
        
        if( !rmin )        rmin = 10000 ;
        if( !rmax )        rmax = 60000 ;

        /* Allocate the memory needed for the tests and change rmax and rmin */
        rmax = rmax - rmin ;
        rmin = (int)malloc( rmax + 4 ) ;
        rmax += rmin ;

        tinput( "TYPE IN DISK DRIVE AND PATH (EG /C/PATH/) ", dskpth ) ;
        strcpy( flname, dskpth ) ;
        strcat( flname, "LOGFILE" ) ;
}         

/* ................................................................................ */
#ifdef LATTICE_C
#undef max
#endif

void calibrate( void )
{
        float low, high, max ;
        int k, i, x, index ;
        clock_t a, b, _time ;
        
        /* Clock Calibration Loop - a really disgusting piece of code (BSI!!!!) */
        calibrat = 2 ;
        
        label1:        low = 10000 ; high = 0 ; index = 0 ;
                calibrat = calibrat * 2 ;
                
        label2:        max = ( rand() % 1000 ) + 1 ;
        
                for( k = 1 ; k <= max ; k++ )
                        ;
                
                b = clock() ;
        
                for( i = 1 ; i <= calibrat ; i++ )
                {
                        for( x = 1 ; x <= 400 ; x++ )
                                ;
                }
        
                a = clock() ;
        
                _time = a - b ;        /* Under C clock ticks are in ticks already */
                if( !_time )        goto label1 ;
                
                if( low > _time )        low = (float)_time ;
                if( high < _time )        high = (float)_time ;
                
                if( low/high > 0.95 )        index++ ;
                else                        goto label1 ;
                
                if( index < 10 )        goto label2 ;
                
        printf("CLOCK CALIBRATION FACTOR %d\n", (int)calibrat ) ;
        (void) ninput( "Hit <Enter> to continue" ) ;
}

void screen_fill( void )
{
        int i, loop, x ;
        clock_t start, middle, finish ;
                
        puts( "STARTING SCREEN FILL TEST" ) ;
        
        /* Pause for screen to be read */
        for( i = 1 ; i <= 100 * calibrat ; i++ )
                ;

        loop = (int)( calibrat*400/(sw*sd) ) + 1 ;
        start = clock() ;
        
        for( x = 1 ; x <= loop ; x++ )
        {
                FORM_FEED ;
                for( i = 1 ; i <= sw*sd ; i++ )
                        ;
        }
        
        middle = clock() ;

        for( x = 1 ; x <= loop ; x++ )
        {
                FORM_FEED ;
                for( i = 1 ; i <= sw*sd ; i++ )
                        putchar( '*' ) ;
        }
        
        finish = clock() ;
        fill = ( (finish-middle) - (middle-start) ) / loop ;
}

void screen_scroll( void )
{
        int i, x ;
        clock_t start, middle, finish ;

        int loop = ( calibrat > 4 ) ? 4 : calibrat ;
        
        puts( "STARTING SCREEN SCROLL TEST" ) ;
        
        /* Pause for screen to be read */
        for( i = 1 ; i <= 100 * calibrat ; i++ )
                ;

        start = clock() ;
        
        for( x = 1 ; x <= loop ; x++ )
        {
                FORM_FEED ;
                for( i = 1 ; i <= 400 ; i++ )
                        ;
        }
        
        middle = clock() ;

        for( x = 1 ; x <= loop ; x++ )
        {
                FORM_FEED ;
                for( i = 1 ; i <= 400 ; i++ )
                        puts("This is a line of 40 characters !!!!!!!!" ) ;
        }
        
        finish = clock() ;
        scroll = ( (finish-middle) - (middle-start) ) / loop ;
}
#ifdef ATW
void pset( x, y )
int x, y ;
{
        char *addr = SBASE + (y << SSTRIDE) + x ;
        *addr = 1 ;
}
#endif

#ifdef LATTICE_C
#include <linea.h>

#define pset( x, y )        putpixel( x, y, 1 )

#endif

void graphics( void )
{
        int i, j, x, loop ;
        clock_t start, middle, finish ;

        puts( "STARTING GRAPHICS TEST" ) ;
        
        /* Pause for screen to be read */
        for( i = 1 ; i <= 100 * calibrat ; i++ )
                ;

#ifdef LATTICE_C
        linea0() ;
#endif

        start = clock() ;        /* These are the wrong way round !! */
        loop = (int)( calibrat*400/(gsw*gsh) ) + 1 ;
        
        for( x = 1 ; x <= loop ; x++ )
        {
                for( i = 0 ; i <= gsw ; i++ )
                {
                        for( j = 0 ; j <= gsh ; j++ )
                                ;
                }
        }
        
        middle = clock() ;
        
        for( x = 1 ; x <= loop ; x++ )
        {
                for( i = 0 ; i <= gsw ; i++ )
                {
                        for( j = 0 ; j <= gsh ; j++ )
                                pset( i, j ) ;
                }
        }
        
        finish = clock() ;
        graph = ( (finish-middle) - (middle-start) ) / loop ;
}

void sequential_mem( void )
{
        int i, y, a ;
        clock_t start, middle, finish ;
        char *peek ;
        
        puts( "STARTING SEQUENTIAL MEMORY ACCESS TEST" ) ;
        
        /* Pause for screen to be read */
        for( i = 1 ; i <= 100 * calibrat ; i++ )
                ;

        start = clock() ;
        
        for( y = 1 ; y <= calibrat ; y++ )
        {
                for( i = rmin ; i <= rmin+400 ; i++ )
                        ;
        }
        
        middle = clock() ;

        for( y = 1 ; y <= calibrat ; y++ )
        {
                for( i = rmin ; i <= rmin+400 ; i++ )
                {
                        peek = (char*)i ;
                        a = *peek ;
                        *peek = a ;
                }
        }

        finish = clock() ;
        seqmem = ( (finish-middle) - (middle-start) ) / calibrat ;
}

void random_mem( void )
{
        int i, y, a ;
        clock_t start, middle, finish ;
        char *peek ;

        puts( "STARTING RANDOM MEMORY ACCESS TEST" ) ;
        
        /* Pause for screen to be read */
        for( i = 1 ; i <= 100 * calibrat ; i++ )
                ;

        start = clock() ;
        
        for( y = 1 ; y <= calibrat ; y++ )
        {
                for( i = rmin ; i <= rmax ; i += (rmax-rmin)/400 )
                        ;
        }
        
        middle = clock() ;

        for( y = 1 ; y <= calibrat ; y++ )
        {
                for( i = rmin ; i <= rmax ; i += (rmax-rmin)/400 )
                {
                        peek = (char*)i ;
                        a = *peek ;
                        *peek = a ;
                }
        }

        finish = clock() ;
        ranmem = ( (finish-middle) - (middle-start) ) / calibrat ;
}

void integer_arith( void )
{
        int i, a, b, x ;
        clock_t start, middle, finish ;

        puts( "STARTING INTEGER ARITHMETIC TEST" ) ;
        
        /* Pause for screen to be read */
        for( i = 1 ; i <= 100 * calibrat ; i++ )
                ;

        a = 2 ; b = 3 ;
        start = clock() ;
        
        for( i = 1 ; i <= calibrat ; i++ )
        {
                for( x = 1 ; x <= 400 ; x++ )
                {
                        a = a ;
                        a = a ;
                }
        }
        
        middle = clock() ;
        
        for( i = 1 ; i <= calibrat ; i++ )
        {
                for( x = 1 ; x <= 400 ; x++ )
                {
                        a = (a+b)*b-(b+a)/(b-a) ;
                        a = a-3*b+1 ;
                }
        }

        finish = clock() ;
        integer = ( (finish-middle) - (middle-start) ) / calibrat ;
}

void real_arith( void )
{
        int i, x ;
        float a, b ;
        clock_t start, middle, finish ;

        puts( "STARTING REAL ARITHMETIC TEST" ) ;
                
        /* Pause for screen to be read */
        for( i = 1 ; i <= 100 * calibrat ; i++ )
                ;
        
        a = 2.154 ; b = 3.982 ;
        start = clock() ;
                
        for( i = 1 ; i <= calibrat ; i++ )
        {
                for( x = 1 ; x <= 400 ; x++ )
                {
                        a = a ;
                        a = a ;
                }
        }
                
        middle = clock() ;
        
        for( i = 1 ; i <= calibrat ; i++ )
        {
                for( x = 1 ; x <= 400 ; x++ )
                {
                        a = (a+b)*b-(b+a)/(b-a) ;
                        a = a-((float)5.518291)*b+3.0509556 ;
                }
        }
        
        finish = clock() ;
        real = ( (finish-middle) - (middle-start) ) / calibrat ;
}

void sequen_disk( void )
{
        int i, j, len ;
        int b ;
        float c ;
        char *a ;
        FILE *f2 ;
        clock_t start, middle, finish ;

        puts( "STARTING SEQUENTIAL DISK ACCESS TEST" ) ;
                
        /* Pause for screen to be read */
        for( i = 1 ; i <= 100 * calibrat ; i++ )
                ;
        
        a = "THIS IS A STRING OF FORTY CHARACTERS!!!!" ;
        b = 32132 ;
        c = 0.0032132 ;

        len = strlen( a ) ;                /* Extra */
        
        start = clock() ;
                
        for( i = 1 ; i <= calibrat/4 ; i++ )
        {
                f2 = fopen( flname, "w+" ) ; 

                for( j = 1 ; j <= 130 ; j++ )
                {
                        a = a ;
                        b = b ;
                        c = c ;
                }

                fclose( f2 ) ;
        }
                
        for( i = 1 ; i <= calibrat/4 ; i++ )
        {
                f2 = fopen( flname, "r" ) ; 

                for( j = 1 ; j <= 130 ; j++ )
                        ;
                        
                fclose( f2 ) ;
        }
                
        middle = clock() ;
                
        for( i = 1 ; i <= calibrat/4 ; i++ )
        {
                f2 = fopen( flname, "w+" ) ; 

                for( j = 1 ; j <= 130 ; j++ )
                {
                        fwrite( a, len, 1, f2 ) ;
                        fwrite( (char*)&b, sizeof( int ), 1, f2 ) ;
                        fwrite( (char*)&c, sizeof( float ), 1, f2 ) ;
                }

                fclose( f2 ) ;
        }
                
        for( i = 1 ; i <= calibrat/4 ; i++ )
        {
                f2 = fopen( flname, "r" ) ; 

                for( j = 1 ; j <= 130 ; j++ )
                {
                        fread( a, len, 1, f2 ) ;
                        fread( (char*)&b, sizeof( int ), 1, f2 ) ;
                        fread( (char*)&c, sizeof( float ), 1, f2 ) ;
                }
                        
                fclose( f2 ) ;
        }
        
        finish = clock() ;
        sequen = ( (finish-middle) - (middle-start) ) / calibrat ;
        remove( flname ) ;
}

void random_disk( void )
{
        struct field {
                char        a[41] ;
                short        b ;
                float        c ;
        } field ;
        
        FILE *f2 ;
        char *mybuf = malloc( sizeof( struct field ) + 4 ) ;
        
        int i, x, j ;
        int b ;
        float c ;
        clock_t start, middle, finish ;

        puts( "STARTING RANDOM DISK ACCESS TEST" ) ;
                
        /* Pause for screen to be read */
        for( i = 1 ; i <= 100 * calibrat ; i++ )
                ;
        
        f2 = fopen( flname, "w+" ) ;
        
        strcpy( field.a, "THIS IS A STRING OF 40 CHARACTERS!!!!!!!!!!!!" ) ;
        b = 15342 ;
        c = 3.7364E-04 ;

        for( i = 1 ; i <= 2000 ; i++ )
                fwrite( (char*)&field, sizeof( struct field ), 1, f2 ) ;
                
        fclose( f2 ) ;
        
        start = clock() ;
                
        for( x = 1 ; x <= calibrat ; x++ )
        {
                f2 = fopen( flname, "r+" ) ; 
                setvbuf( f2, mybuf, _IOFBF, sizeof( struct field ) ) ;

                for( i = 20 ; i <= 980 ; i += 20 )
                {
                        for( j = 1000-i ; j <= 1000+i ; j += 2*i )
                        {
                                strcpy( field.a, field.a ) ;
                                field.b = field.b ;
                                field.c = field.c ;
                        }
                }

                fclose( f2 ) ;
        }

        middle = clock() ;
                
        for( x = 1 ; x <= calibrat ; x++ )
        {
                f2 = fopen( flname, "r+" ) ; 
                setvbuf( f2, mybuf, _IOFBF, sizeof( struct field ) ) ;

                for( i = 20 ; i <= 980 ; i += 20 )
                {
                        for( j = 1000-i ; j <= 1000+i ; j += 2*i )
                        {
                                fseek( f2, (2000-j)*sizeof( struct field ), SEEK_SET ) ;
                                fread( (char*)&field, sizeof( struct field ), 1, f2 ) ;
                                fwrite( (char*)&field, sizeof( struct field ), 1, f2 ) ;
                        }
                }

                fclose( f2 ) ;
        }
        
        finish = clock() ;
        random = ( (finish-middle) - (middle-start) ) / calibrat ;
        remove( flname ) ;
}

void get_sizes( void )
{
        float         reel, old ;
        
        /* Just print the number of bits for integers */
        printf("THE MACHINE USED %d bit integers\n", sizeof( int ) * CHAR_BIT ) ;
        
        reel = 1 ;
        
        while( 1 )
        {
                old = reel ;
                reel /= 2 ;
                if( (float)1.0 - reel == (float)1.0 )        break ;
        }
        
        printf("THE SMALLEST VALUE WHICH CAN BE REPRESENTED EXACTLY IS: %e\n", old ) ;
        printf("THE POSITIVE EXPONENT RANGE %d\n", FLT_MAX_10_EXP ) ;
}

void output( void )
{
        float calc, scr, disc, memry, pcwhi ;
         
        FORM_FEED ;
        
        printf("RESULTS FOR THE PCW HARDWARE INDEX ON %s\n", tmach ) ;
        printf(" USING %s LANGUAGE\n", tinter ) ;
        putchar( '\n' ) ;
        puts("TEST CONDITIONS WERE:"); 
        putchar( '\n' ) ;

        get_sizes() ;

        if( integer/real > 0.95 )        
                puts("   (INTEGER CALCULATION IS NOT DIFFERENT FROM REAL)" ) ;
        
        puts("A") ;
        
        if        ( sc == 1 )        puts( " CGA" ) ;
        else if        ( sc == 2 )        puts( "N EGA" ) ;
        else                        puts( " VGA" ) ;
        
        printf( " MONITOR ( %d by %d IN TEXT MODE ) WAS TESTED\n", sw, sd ) ;
        printf( "THE AREA OF MEMORY TESTED WAS FROM %d TO %d (DECIMAL)\n", rmin, rmax ) ;
        printf( "THE DRIVE USED FOR THE DISK TEST WAS %s\n", dskpth ) ;
        
        tinput( "PRESS <ENTER> TO CONTINUE", tmach ) ;        /* tmach no longer needed */
        
        /* Calculate out to 1/100ths of a sec */
        fill *= (100.0 / CLK_TCK) ;
        scroll *= (100.0 / CLK_TCK) ;
        graph *= (100.0 / CLK_TCK) ;
        integer *= (100.0 / CLK_TCK) ;
        real *= (100.0 / CLK_TCK) ;
        sequen *= (100.0 / CLK_TCK) ;
        random *= (100.0 / CLK_TCK) ;
        seqmem *= (100.0 / CLK_TCK) ;
        ranmem *= (100.0 / CLK_TCK) ;
        
        FORM_FEED ;
        
        puts( "    RAW TIMES FOR THE TESTS WERE:" ) ;
        puts( " +------------------------+-----------------+" ) ;
        puts( " |         TEST           |  TIME (sec/100) |" ) ;
        puts( " +------------------------+-----------------+" ) ;

        printf( " | SCREEN FILL            | %10.5e             |\n", fill ) ;
        printf( " | SCREEN SCROLL          | %10.5e             |\n", scroll ) ;
        printf( " | GRAPHICS TEST          | %10.5e             |\n", graph ) ;
        printf( " | INTEGER TEST           | %10.5e             |\n", integer ) ;
        printf( " | REAL TEST              | %10.5e             |\n", real ) ;
        printf( " | SEQUENTIAL DISK        | %10.5e             |\n", sequen ) ;
        printf( " | RANDOM DISK            | %10.5e             |\n", random ) ;
        printf( " | SEQUENTIAL MEMORY TEST | %10.5e             |\n", seqmem ) ;
        printf( " | RANDOM MEMORY TEST     | %10.5e             |\n", ranmem ) ;

        puts( " +------------------------+-----------------+" ) ;
        
        calc = ( 276/integer + 256/real ) / 2 ;
        scr = ( 253/fill + 1852/scroll + 14002/graph ) / 3 ;
        disc = ( 171/sequen + 702/random ) / 2 ;
        memry = ( 102/seqmem + 130/ranmem ) / 2 ;
        pcwhi = ( sqrt( sqrt( scr * calc * disc * memry ) ) ) ;
        
        tinput( "PRESS <ENTER> TO CONTINUE", tmach ) ;        /* tmach no longer needed */
        
        FORM_FEED ;
        
        puts( " +-----------+-------------+------------+-------------+" ) ;
        puts( " |  SCREEN   | COMPUTATION |    DISK    |   MEMORY    |" ) ;
        puts( " +-----------+-------------+------------+-------------+" ) ;

        printf( " |  %5.1f    |   %5.1f     |  %5.1f     |   %5.1f     |\n", 
                                                        scr, calc, disc, memry ) ;

        puts( " +-----------+-------------+------------+-------------+" ) ;
        putchar( '\n' ) ;

        printf( "   PCW HARDWARE INDEX is %5.1f\n", pcwhi ) ;
}        
                                                        
void bsi( void )
{
        /* Change buffering */
/*        setvbuf( stdout, NULL, _IONBF, 0 ) ; */
                
        user_input() ;
        
        puts( "PCW HARDWARE INDEX VERSION 1.1" ) ;
        putchar( '\n' ) ;

        puts( "INVESTIGATING THE CLOCK RESOLUTION" ) ;
        calibrate() ;

        screen_fill() ;
        screen_scroll() ;
        graphics() ;
        sequential_mem() ;
        random_mem() ;
        integer_arith() ;
        real_arith() ;
        sequen_disk() ;
        random_disk() ;
        
        output() ;
}

/* -------------------------------------------------------------------------------- */

void pcw( void )
{
        clock_t intmath, realmath, triglog, textscrn, 
                grafscrn, storefd, storehd, blitscrn ;
                
        float pcwindex ;

        FORM_FEED ;
                
        intmath = clock() ;
        
        /* Intmath */
        {
                int x,y,i ;
        
                x = 0 ; y = 9 ;
        
                puts( "Start" ) ;
        
                for( i = 0 ; i < 1000 ; i++ )
                        x += ( y * y - y ) / y ;
        
                printf( "Finish" ) ;
                printf( "%d\n", x ) ;
        }

        intmath = clock() - intmath ;
        realmath = clock() ;
        
        /* Realmath */
        {
                float x, y ;
                int i ;
        
                x = (float)0.0 ; y = (float)9.9 ;
        
                puts( "Start" ) ;
        
                for( i = 0 ; i < 1000 ; i++ )
                        x += ( y * y - y ) / y ;
                
                printf( "Finish" ) ;
                printf( "%f\n", x ) ;
        }
        
        realmath = clock() - realmath ;
        triglog = clock() ;
        
        /* Triglog */
        {
                float x, y ;
                int i ;
                
                x = (float)0.0 ; y = (float)9.9 ;
                
                puts( "Start" ) ;
                
                for( i = 0 ; i < 1000 ; i++ )
                        x += sin( atan( cos( log( y ) ) ) ) ;
                        
                printf( "Finish" ) ;
                printf( "%f\n", x ) ;
        }
        
        triglog = clock() - triglog ;
        textscrn = clock() ;
        
        /* Textscrn */
        {
                int i ;
                
                puts( "Start" ) ;
                
                for( i = 0 ; i < 1000 ; i++ )
                {
                        printf("1234567890qwertyuiop" ) ;
                        printf( "%d\n", i ) ;
                }
                
                puts( "Finish" ) ;
        }
        
        textscrn = clock() - textscrn ;
        grafscrn = clock() ;
        
        /* GrafScrn */
        {
                int i, j ;

#ifdef LATTICE_C
                linea0() ;
#endif
                
                puts( "Start" ) ;
                
                for( i = 0 ; i < 100 ; i++ )
                {
                        for( j = 0 ; j < 100 ; j++ )
                        {
#ifdef ATW
                                char *pixel = SBASE + (i << SSTRIDE) + j ;
                                *pixel = 4 ;
#endif

#ifdef LATTICE_C
                                pset( i, j ) ;
#endif
                        }
                }
                
                puts( "Finish" ) ;
        }
        
        grafscrn = clock() - grafscrn ;
        storefd = clock() ;
        
        /* StoreFD */
        {
                int i ;
                FILE *test ;
                
                puts( "Start" ) ;
                
                test = fopen( FLOPPY_FILE, "w" ) ;
                
                for( i = 0 ; i < 1000 ; i++ )
                        fputs( "1234567890qwertyuiop", test ) ;
                        
                fclose( test ) ;
                remove( FLOPPY_FILE ) ;
                
                puts( "Finish" ) ;
        }
        
        storefd = clock() - storefd ;
        storehd = clock() ;
        
        /* StoreHD */
        {
                int i ;
                FILE *test ;
                
                puts( "Start" ) ;
                
                test = fopen( HARD_FILE, "w" ) ;
                
                for( i = 0 ; i < 1000 ; i++ )
                        fputs( "1234567890qwertyuiop", test ) ;
                        
                fclose( test ) ;
                remove( HARD_FILE ) ;
                
                puts( "Finish" ) ;
        }
        
        storehd = clock() - storehd ;

        pcwindex        = (6.200/(intmath/CLK_TCK.0))
                        * (7.000/(realmath/CLK_TCK.0))
                        * (52.500/(triglog/CLK_TCK.0))
                        * (89.800/(textscrn/CLK_TCK.0))
                        * (49.000/(grafscrn/CLK_TCK.0))
                        * (36.110/(storefd/CLK_TCK.0))
                        * (12.700/(storehd/CLK_TCK.0)) ;
                        
        pcwindex = pow( pcwindex, (1.0/7.0) ) ;
        
        printf( "Intmath = %f, Realmath = %f, Triglog = %f, Textscrn = %f,\n",
                intmath/CLK_TCK.0, realmath/CLK_TCK.0, triglog/CLK_TCK.0,
                textscrn/CLK_TCK.0) ; 

        printf( "Grafscrn = %f, StoreFD = %f, StoreHD = %f\n",
                grafscrn/CLK_TCK.0, storefd/CLK_TCK.0, storehd/CLK_TCK.0 ) ;
                
        printf( "PCW Index = %f\n", pcwindex ) ;
}

/* -------------------------------------------------------------------------------- */        

void s6( void )
{
        return ;
}

void s4( void )
{
        return ;
}

void s3( void )
{
        return ;
}

void old( void )
{
        clock_t times[8] ;        /* To hold the times */
        clock_t t ;                /* Running store for times */
        float        k ;                /* Loop counter */
        float        a, b, c ;        /* Floating point variables */
        int        i ;
        
        t = clock() ;
        
        for( k = 1 ; k <= 10000 ; k++ )
                ;
                
        t = clock() - t ;        times[0] = t ;
        
        t = clock() ;
        k = 0 ;
        z1 :
        {
                k++ ;        
                if( k < 10000 )        goto z1 ;
        }
        
        t = clock() - t ;        times[1] = t ;
        
        t = clock() ;
        k = 0 ;
        z2 :
        {
                k++ ;
                a = (k/k) * k + k - k ;
                if( k < 10000 ) goto z2 ;
        }
        
        t = clock() -t ;        times[2] = t ;
        
        t = clock() ;
        k = 0 ;
        z3 :
        {
                k++ ;
                a = k/2 * 3 + 4 - 5 ;
                if( k < 10000 )        goto z3 ;
        }
        
        t = clock() -t ;        times[3] = t ;
        
        t = clock() ;
        k = 0 ;
        z4 :
        {
                k++ ;
                a = k/2 * 3 + 4 - 5 ;
                s4() ;
                if( k < 10000 ) goto z4 ;
        }
        
        t = clock() -t ;        times[4] = t ;
        
        t = clock() ;
        k = 0 ;
        {
                int l ;

                z5 :
                {
                        k++ ;
                        a = k/2 * 3 + 4 - 5 ;
                        s3() ;
                        for( l = 0 ; l < 5 ; l++ )        /* Note C arrays start from 0 */
                                ;
                
                        if( k < 10000 ) goto z5 ;
                }
        }
        
        t = clock() -t ;        times[5] = t ;
        
        t = clock() ;
        k = 0 ;
        {
                int l ;
                float m1[5] ;

                z6 :
                {
                        k++ ;
                        a = k/2 * 3 + 4 - 5 ;
                        s6() ;
                        for( l = 0 ; l < 5 ; l++ )        /* Note C arrays start from 0 */
                                m1[l] = a ;
                
                        if( k < 10000 ) goto z6 ;
                }
        }
        
        t = clock() -t ;        times[6] = t ;
        
        t = clock() ;
        k = 0 ;
        z7 :
        {
                k++ ;
                a = pow( k, 2 ) ;
                b = log( k ) ;
                c = sin( k ) ;
                if( k < 10000 )        goto z7 ;
        }
        
        t = clock() -t ;        times[7] = t ;
                
        t = 0 ;
        for( i = 0 ; i < 8 ; i++ )
        {
                printf( "PCW %d = %f\n", i+1, (times[i]/CLK_TCK.0)/10 ) ;
                t += times[i] ;
        }
        
        printf( "PCW Average = %f\n", t / (CLK_TCK.0 * 8 * 10) ) ;
}

/* -------------------------------------------------------------------------------- */
        
int main( void )
{
        char reply[100] ;

#ifdef LATTICE_C
        fputs("\0x1bv", stdout ) ;
        FORM_FEED ; 
#endif

        bsi() ;

        tinput( "<RETURN> to continue, another key to stop", reply ) ;
        if( ! *reply )
        {
                old() ;

                tinput( "<RETURN> to continue, another key to stop", reply ) ;
                if( ! *reply )
                {
                        pcw() ;
                        tinput( "Any key to finish", reply ) ;
                }
        }

        return( 0 ) ;
}
