/* emulate.c :	Routine to emulate blossom address generator */

#include <glocal.h>
#include <stdio.h>

BCreg BCInit( void )
{
	BCreg bc ;
	
	bc.SYC  = PlusStride ;
	bc.SXC  = PlusCounter ;
	bc.SPS  = 1 ;
	bc.DYC  = PlusStride ;
	bc.DXC  = PlusCounter ;
	bc.DPS  = 1 ;
	bc.DQ   = 0 ;
	bc.MPR  = 0 ;
	bc.MPS  = 1 ;
	bc.EOLS = 0 ;
	bc.FCEN = 1 ;
	bc.MSK  = 0 ;
	bc.DST  = 0 ;
	bc.SRC  = 1 ;
	bc.STP  = 0 ;
	bc.SSH  = 0 ;
	bc.SSP  = 0 ;
	bc.RESB = 0 ;
	bc.GO   = 0 ;
	
	return( bc ) ;
}

void BloPlot( int ds, int ss )
{
	int lx, ly, rx, ry ;
	
	ds -= ScreenBaseinNibbles ;
	ss -= ScreenBaseinNibbles ;
	
	lx = NibbAddrtoX( ds ) >> NibblesPerPixelShift ;
	ly = NibbAddrtoY( ds ) ;
	rx = NibbAddrtoX( ss ) >> NibblesPerPixelShift ;
	ry = NibbAddrtoY( ss ) ;

	printf( "(%4d,%4d)(%4d,%4d)\n", lx, ly, rx, ry ) ;
}
	
void BloEmulate( BlitterPtr blo, BCreg bc )
{
	int ds = blo->DS ;
	int ss = blo->SS ;
	int dl = blo->DL ;
	int df = blo->DF & BlitFractionMask ;
	int sf = blo->SF & BlitFractionMask ;
	int dps = 1 << bc.DPS ;
	int sps = 1 << bc.SPS ;
	int di = blo->DI & BlitFractionMask ;
	int si = blo->SI & BlitFractionMask ;
	int width = 0 ;
	
	if( bc.EOLS )	width = blo->DW ;
	else		width = ss - ds ;
		
	while( dl >= 0 )
	{
		BloPlot( ds, ss ) ;
		width-- ;
	
		if( width <= dps )
		{
			df += di ;

			if( df > BlitFractionMask )
			{
				if( bc.FCEN )	ds += dps ; 
				df = GetBlitFractions( df ) ;
			}

			sf += si ;

			if( sf > BlitFractionMask )
			{
				if( bc.FCEN )	ss += sps ;
				sf = GetBlitFractions( sf ) ;
			}

			if	( bc.DYC == PlusStride )	ds += blo->DT ;
			else if ( bc.DYC == PlusCounter )	ds++ ;
			else if ( bc.DYC == MinusStride )	ds -= blo->DT ;
			else					ds-- ;

			if	( bc.SYC == PlusStride )	ss += blo->ST ;
			else if ( bc.SYC == PlusCounter )	ss++ ;
			else if ( bc.SYC == MinusStride )	ss -= blo->ST ;
			else					ss-- ;
			
			if( bc.EOLS )	width = blo->DW ;
			else		width = ss - ds ;
			
			dl-- ;
		}
		else
		{
			if	( bc.DXC == PlusStride )	ds += blo->DT ;
			else if ( bc.DXC == PlusCounter )	ds++ ;
			else if ( bc.DXC == MinusStride )	ds -= blo->DT ;
			else					ds-- ;

			if	( bc.SXC == PlusStride )	ss += blo->ST ;
			else if ( bc.SXC == PlusCounter )	ss++ ;
			else if ( bc.SXC == MinusStride )	ss -= blo->ST ;
			else					ss-- ;
		}
	}
}
