#include <glocal.h>
#include <stdio.h>

void (*LineBlit)() = LineBlitB ;

/* -------------------------------------------------------------------------------- */

void LineBlitT( int x, int y, int dy, int m, TGCValues *values )
{
	x = x ;
	y = y ;
	dy = dy ;
	m = m ;
	values = values ;
	fputs( "LineBlitT() not implemented\n", stderr ) ;
}

/* -------------------------------------------------------------------------------- */

void LineDrawT( int x1, int y1, int x2, int y2, TGCValues *values )
{
	int 	s, dx, dy, m, e ;
	char 	*addr ;
	int	stride = StrideinBytes ;
	
	if( y1 != y2 )
	{
		if( y1 > y2 )
		{
			dy = y1 - y2 ;
			y1 = y2 ;
			dx = x1 - x2 ;
			x1 = x2 ;
		}
		else
		{
			dy = y2 - y1 ;
			dx = x2 - x1 ;
		}

		addr = (char*)ScreenBaseinBytes + ( y1 << StrideinBytesShift ) + x1 ;
		
		if( dx )
		{
			int fg = values->fg ;
		
			if( dx < 0 )
			{
				dx = -dx ;
				s  = -1 ;
			}
			else	s  = +1 ;
			 			
			if( dx > dy )
			{
				dy <<= 1 ;
				e = dy - dx ;		
				m = dx << 1 ;
				
				while( dx >= 0 )
				{
					*addr = fg ;

					if( e >= 0 )	
					{
						addr += stride ;
						e -= m ;
					}
					
					e += dy ;
					addr += s ;
					dx-- ;
				}
			}
			else if( dx < dy )
			{
				dx <<= 1 ;
				e = dx - dy ;
				m = dy << 1 ;
				
				while( dy >= 0 )
				{
					*addr = fg ;

					if( e >= 0 )	
					{
						addr += s ;
						e  -= m ;
					}
					
					e += dx ;
				 	addr += stride ;
				 	dy-- ;
				}
			}
			else
			{
				*addr = values->fg ;
				stride += s ;
				bytblt( addr, addr + stride, 0,0, 0,stride, dy,1, 0 ) ;
			}
		}
		else
		{
			*addr = values->fg ;
			bytblt( addr, addr + stride, 0,0, 0, stride, dy,1, 0 ) ;
		}
	}
	else
	{
		if( x1 > x2 )
		{
			dx = x1 - x2 ;
			x1 = x2 ;
		}
		else	dx = x2 - x1 ;
		
		addr = (char*)ScreenBaseinBytes + ( y1 << StrideinBytesShift ) + x1 ;
		*addr = values->fg ;
		bytblt( addr, addr + 1, 0,0, 0,1, dx,1, 0 ) ;
	}
}

/* -------------------------------------------------------------------------------- */

void LineDrawB( int x1, int y1, int x2, int y2, TGCValues *values )
{
	int 	li, lt, lf, dx, dy, e ;

#ifdef TESTING
	BCreg	bc ;
	Blitter blo ; 
	blitter = &blo ;
	values = values ;
	bc = BCInit() ;
#else
	int	bc = InitBlit( blitter, values, TypePolygon ) ;	
#endif
	
	if( y1 > y2 )
	{
		dy = y1 - y2 ;
		y1 = y2 ;
		dx = x1 - x2 ;
		x1 = x2 ;
	}
	else
	{
		dy = y2 - y1 ;
		dx = x2 - x1 ;
	}

	x1 = ScreenBaseinNibbles + YtoNibbAddr(y1) + (x1<<NibblesPerPixelShift) ;
	
	if( dx >= 0 )
	{
		/* If dx > dy use the fraction method, otherwise the dda method */
		if( dx >= dy )	
		{
			dx = PixelstoFractions( dx + 1 ) / ( dy + 1 ) ;
			lt = WholeNibbles( dx ) ;
			x2 = x1 + lt ;
			li = GetBlitFractions( dx ) ;
			lt += StrideinNibbles ;
			lf = HalfBlitFraction + dx - lt ;
		}
		else
		{
			dx = ( dx << BlitFractionShift ) + ( dy >> 1 ) ;
			li = dx / dy ;
			x2 = x1 ;
			lt = StrideinNibbles ;
			lf = HalfBlitFraction + li + ( ( dx - li * dy ) >> 1 ) ;
		}
	}
	else
	{
		dx = -dx ; 
		dx = PixelstoFractions( dx + 1 	) / ( dy + 1 ) ;
		lt = WholeNibbles( dx ) ;
		x2 = x1 ;
		x1 = x2 - lt ;
		li = GetBlitFractions( dx ) ;

		if( li )
		{
			li = BlitFractions - li ;
			lt = StrideinNibbles - lt + NibblesPerPixel ;
		}
		else	lt = StrideinNibbles - lt ;
	}

	blitter->DT = blitter->ST = lt ; 
	blitter->DI = blitter->SI = li ;
	blitter->DF = blitter->SF = lf ;
	blitter->DS = x1 ;
	blitter->SS = x2 ;
	blitter->DL = dy ;
	blitter->DW = 0 ;
#ifdef TESTING
	bc.DYC = bc.SYC = PlusStride ;
	bc.DXC = bc.SXC = PlusCounter ;
	BloEmulate( &blo, bc ) ;
#else
	blitter->BC = bc ;
#endif
}		

/* -------------------------------------------------------------------------------- */

void LineBlitB( int x, int y, int dy, int m, TGCValues *values )
{
	x = x ;
	y = y ;
	dy = dy ;
	m = m ;
	values = values ;
}

/* -------------------------------------------------------------------------------- */

void	TDrawLine( TDrawable drawable, TGC gc, int x1, int y1, int x2, int y2 )
{
	int	tlx, tly ;
	int	dy ;

	drawable	= drawable ;
	
	/* For now just set tlx, tly to 0 */
	tlx	= 0 ;
	tly	= 0 ;

	x1 += tlx ;
	x2 += tlx ;
	y1 += tly ;
	y2 += tly ;
		
	if( LineBlit == LineBlitB ) 	LineDrawB( x1, y1, x2, y2, &gc->values ) ; 
	else				LineDrawT( x1, y1, x2, y2, &gc->values ) ; 
	
	{
		x1	= PixelstoFractions( x1 ) + HalfPixelinFractions ;
		x2	= PixelstoFractions( x2 ) + HalfPixelinFractions ;
	
		if( y1 == y2 )
		{
			if( x2 < x1 )	LineBlit( x2, y2, 0, x1 - x2, &gc->values ) ;
			else		LineBlit( x1, y1, 0, x2 - x1, &gc->values ) ;
		}
		else if( y1 < y2 )	
		{
			dy	= y2 - y1 ;
			LineBlit( x1, y1, dy, ( x2 - x1 ) / dy, &gc->values ) ;
		}
		else
		{
			dy	= y1 - y2 ;
			LineBlit( x2, y2, dy, ( x1 - x2 ) / dy, &gc->values ) ;
		}
	}
}

/* -------------------------------------------------------------------------------- */
/* ----------------------------------- line.c ------------------------------------- */
