#include <stdio.h>
#include <stdlib.h>
#include <codes.h>

#include <blossom.h>

/* Structure used to send in data */
typedef struct CoOrd {
	short	x ;
	short	y ;
} CoOrd ;

/* Structure used to store the active edges */
typedef struct Edge {
	struct Edge	*NextX ;	/* Next X Node */
	short		y ;		/* Value of y */
	short		dy ;		/* Delta y */
	int		x ;		/* Start X co-ordinate (in Nibble Fractions) */
	int		m ;		/* dx/dy */
} Edge ;

/* Structure used to store Y Buckets */
typedef struct YBucket {
	struct YBucket	*NextY ;	/* Next Y Bucket */
	struct YBucket	*PrevY ;	/* Prev Y Bucket */
	Edge		*NextX ;	/* First X Entry */
	int		y ;		/* Value of y */
} YBucket ;

/* The following are used by the blitter */
#define		 	PixelSize	1
static const int 	BCforTFill 	= BCgo + BCfcen*1 + BCeols*0 + ( BCdps + BCsps ) * PixelSize 
					+ BCdxc*1 + BCdyc*0 + BCsxc*1 + BCsyc*0 + BCdst*1 ;
					
static BlitterPtr	blitter = BLITTER_BASE ;

#define InitFillBlit( bptr,data ) 	( (bptr)->PM = 0xFFFFFFFF, \
					  (bptr)->BC = BCssp + BCssh, \
					  (bptr)->SD = (data), \
					  (bptr)->BF = BFcopy, \
					  (bptr)->TC = 0x1 )


#define SOAK_TEST

extern void bytblt( char *, char *, int,int, int,int, int,int, int ) ;

static const int	Convex		= 1,
			Nonconvex	= 2;

/* The following variables are determined from the mode information */
static const int	ScreenBaseinBytes	= 0x00200000 ;
static const int	StrideinPixels		= 2048 ;

/* The following variables are extracted from the byte based knowledge of the system */
static const int	BitsPerWord		= 32 ;
static const int	NibbleFraction		= 2048 ;	/* Accuracy of nibble calcs */
static const int	AddressFraction		= 4096 ;	/* Accuracy of line draw */
static const int	NibbtoAddrFracShift	= 1 ;		/* Difference between above */

/* The following global variables are set up by InitBlossomGraphics */
static int		PixelSize,				/* Bits to shift to nibbles */
			PixeltoNibbFracShift,
			ScreenBaseinBytes,
			ScreenBaseinNibbles,
			StrideinPixels,
			StrideinNibbles,
			StrideShiftinPixels,
			StrideShiftinNibbles,
			ScreenWidthinPixels,
			ScreenHeightinPixels,
			BitsPerPixel,
			NibbleFractionMask,
			AddressFractionMask,
			HalfPixelinFractions,
			
			
#define PixelstoNibbles( x )	( (x) << PixeltoNibbleShift )
#define NibblestoPixels( x )	( (x) >> PixeltoNibbleShift )
#define PixelstoNibbFracs( x )	( (x) << PixeltoNibbFracShift )
#define NibbFracstoPixels( x )	( (x) >> PixeltoNibbFracShift )
#define NibbleFraction( x )	( (x) &  NibbleFractionMask )

#define ExpandColour( x )	( { int n = BitsPerPixel ; \
				  while( n < BitsPerWord )  (x) |= ((x) << n), n <<= 1 ; } ) 
				  
void InitLowLevelGraphics( int mode )
{
	switch( mode )
	{
		case	0 :	/* Mode 0, etc */
		{
			/* Fill in for mode 0 when ready */
		}
		
		default	:	/* 1024 by 768, 8-bit pixels, 256 Colours */
		{
			ScreenBaseinBytes	= 0x00200000 ;
			StrideinPixels		= 2048 ;
			StrideShiftinPixels	= 11 ;
			ScreenWidthinPixels	= 1024 ;
			ScreenHeightinPixels	= 768 ;
			PixelSize		= 1 ;
			BitsPerPixel		= 8 ;
		}
	}
	
	PixeltoNibbFracShift 	= FractionShift + PixelSize ;
	NibbleFractionMask	= NibbleFraction - 1 ;
	AddressFractionMask	= AddressFraction - 1 ;
	HalfPixelinFractions	= ( 1 << ( PixeltoNibbFracShift - 1 ) ) - 1 ;
	ScreenBaseinNibbles	= ScreenBaseinBytes << 1 ;
	StrideinNibbles		= StrideinPixels << PixelSize ;
	StrideShiftinNibbles	= StrideShiftinPixels + PixelSize ;
}

/* -------------------------------------------------------------------------------- */
