/* testmain.c	: Testing routine
 */

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include <graphics.h>

#define	 MAX_POINTS	50

static TPoint	data[MAX_POINTS] ;
static char	buf[BUFSIZ] = "Dummy" ;

int main( int argc, char *argv[] )
{
	int	error ;
	TGC	gc ;
	int	processor ;
	
	argc = argc ;
	argv = argv ;
	
	gc = TCreateGC( NULL ) ;
#ifndef DEMO
	fputs( "Blossom ? ", stdout ) ; fflush( stdout ) ;
	gets( buf ) ;

	if( *buf )	processor = BlossomBlitter ;
	else		processor = TransputerT800 ;

	*buf = 'a' ;
	
	TOpenDisplay( 1, processor ) ;
	
	while( *buf )
	{
		fputs( "> ", stdout ) ;	fflush( stdout ) ;
		gets( buf ) ;
		
		if( *buf )
		{
			int 	i = 0 ;
			char 	*s = buf ;

			while( i < MAX_POINTS )
			{
				data[i].x = strtol( s, &s, 0 ) ;
				data[i].y = strtol( s, &s, 0 ) ;
				
				if( data[i].y == 0 )	break ;
				else			i++ ;
			}
#else
	processor = -1 ;
	while( processor < 0 ) 
	{
		{
			int	i ;
			
			if( *argv[1] == 'b'  ||  *argv[1] == 'B' )	
			{
				data[0].x = 2 ;
				processor = BlossomBlitter ;
			}
			else	
			{
				data[0].x = 512 ;
				processor = TransputerT800 ;
			}
			
			data[0].y = 2 ;
			data[1].x = data[0].x + 508 ;
			data[1].y = 766 ;
			data[2].x = 200 ;
			TOpenDisplay( 1, processor ) ;
#endif
			
#ifdef SOAK_TEST
			{
				int	min_x, min_y, dx, dy, count ;
			
				min_x = data[0].x ;
				min_y = data[0].y ;
				dx    = data[1].x - min_x ;
				dy    = data[1].y - min_y ;
				count = data[2].x ;

				srand( 1 ) ;
				
				for( i = count ; i > 0 ; i-- )
				{
					data[0].x = min_x + rand() % dx ;
					data[0].y = min_y + rand() % dy ;
					data[1].x = min_x + rand() % dx ;
					data[1].y = min_y + rand() % dy ;
					data[2].x = min_x + rand() % dx ;
					data[2].y = min_y + rand() % dy ;
					data[3].x = min_x + rand() % dx ;
					data[3].y = min_y + rand() % dy ;
					gc->values.fg	  = rand() % 60 ;

					error = TFillPolygon( 0, gc, data, 4, 
									Nonconvex, Origin ) ;
					if( error )	break ;
				}
			}
#else
			{
				TPoint *p1, *p2 ;
				int	j ;

				gc->values.fg	  = 255 ;
				error = TFillPolygon( 0, gc, data, i, Nonconvex, Origin ) ;

				p2 = data ;
				
				gc->values.fg	  = 0 ;
				
				for( j = i ; j > 0 ; j-- )
				{
					p1 = p2 ;
					
					if( j == 1 )	p2 = data ;
					else		p2++ ;
					
					TDrawLine( 0, gc, p1->x, p1->y, p2->x, p2->y ) ;
				}
				
				fputs( "Hit <Return> to continue > ", stdout ) ;
				fflush( stdout ) ;
				gets( buf ) ;

				*buf = ' ' ;
				*(buf+1) = '\0' ;
				
				gc->values.fg	  = 255 ;
				
				p2 = data ;
				
				for( j = i ; j > 0 ; j-- )
				{
					p1 = p2 ;
					
					if( j == 1 )	p2 = data ;
					else		p2++ ;
					
					TDrawLine( 0, gc, p1->x, p1->y, p2->x, p2->y ) ;
				}
				
				gc->values.fg	  = 0 ;
				error = TFillPolygon( 0, gc, data, i, Nonconvex, Origin ) ;
			}
			
#endif
		}
		
		if( error )	break ;
	}
	
	return( error ) ;
}
