#include <stdio.h>
#include <limits.h>
#include <sys/types.h>
#include <dirent.h>
#include <gsp.h>
#include <string.h>

int getpath( char *directory, char *search_object, char *path )
{
	DIR *dp ;
	struct dirent *dir_entry ;
	int error = 0 ;

	printf("Searching directory '%s' ....\n", directory ) ;
		
	if ( ( dp = opendir( directory ) ) == NULL )
	{
		perror("getpath : failure reading directory" ) ;
		return( -1 ) ;
	}
	
	while ( 1 )
	{
		dir_entry = readdir( dp ) ;
		
		if ( dir_entry != NULL )
		{
			char *s = dir_entry->d_name ;

			while ( *s == '.' )
				s++ ;

			if ( *s == '\0' )	continue ;
			
			if ( strcmp( dir_entry->d_name, search_object ) == 0 )
			{
				char s[10] ;
				
				printf("%s found in %s, <Q> to quit > ",
					search_object, directory ) ;
				fflush( stdout ) ;
				
				fgets( s, 10, stdin ) ;
				if( *s == 'q' ||  *s == 'Q' )
				{ 
					error = 2 ;
					break ;
				}
				else	error = 1 ;
			}
			else if ( dir_entry->d_type & Type_Directory )
			{
				char temp_dir[PATH_MAX] ;
				int result ;
				
				strcpy( temp_dir, directory ) ;
				strcat( temp_dir, "/" ) ;
				strcat( temp_dir, dir_entry->d_name ) ;
				result = getpath( temp_dir, search_object, path ) ;	/* recursive */
				error |= result ;
				if ( error > 1 )	break ;
			}
		}
		else
		{
			if ( errno )	error = errno ;
			break ; 
		}
	}
	
	if ( closedir( dp ) )	error = -1 ;
	
	return( error ) ;
}

int main( int argc, char *argv[] )
{
	int error = 0 ;
	
	if ( argc >= 2 )
	{
		int i ;
		char path[PATH_MAX] ;
		
		*path = '\0' ;
		
		if ( argc < 3 )
		{
			error = getpath( ".", argv[1], path ) ;
		}
		else
		{
			for ( i = 2 ; i < argc ; i++ )
			{
				error = getpath( argv[i], argv[1], path ) ;
				if ( error )	break ;
			}
		}
		
		if 	( error < 0 )	fprintf( stderr, "Error number %d whilst searching for file\n", errno ) ;
		else if ( error == 0 )	fprintf( stderr, "Unable to find file <%s>\n", argv[1] ) ;

		if ( *path != '\0' )	printf( "File <%s> found in directory <%s>\n", argv[1], path ) ;
	}
	else	fprintf( stderr, "Syntax : %s <search_file> <directories>\n", argv[0] ) ;
}
				
